=begin header
    Gimp-Ruby - allows the writing of Gimp plugins in Ruby.
    Copyright (C) 2001  Masahiro Sakai
 
          Masahiro Sakai                  <zvm01052@nifty.ne.jp>
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
    
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.
    
    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the
    Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
=end


module Gimp

  Shelf = Object::new()

  class <<Shelf
    def [](key)
      begin
        bytes, data = PDB.gimp_procedural_db_get_data(key)
        Marshal.load(data)
      rescue PDB::ExecutionError
        nil
      end
    end

    def has_key?(key)
      begin
        PDB.gimp_procedural_db_get_data_size(key)
        true
      rescue PDB::ExecutionError
        false
      end
    end

    def []=(key, obj)
      data = Marshal(obj)
      PDB.gimp_procedural_db_set_data(key, data.size, data)
    end
  end

end
