#!/usr/bin/env ruby
require "gimp"
require "gimpfu"
include Gimp

def erase_rows(img, drawable, orientation, which, type)
  width  = drawable.width
  height = drawable.height

  img.undo_group {
    which.step(((orientation == 0) ? height : width) - 1, 2) { |i|
      if orientation == 0
	rect_select(img, 0, i, width, 1, REPLACE, false, 0)
      else
	rect_select(img, i, 0, 1, height, REPLACE, false, 0)
      end
      if type == 0
        edit_clear(drawable)
      else
        edit_fill(drawable, BG_IMAGE_FILL)
      end
    }
    selection_none(img)
  }
  displays_flush
end


register(
"ruby_fu_erase_rows",
"Erase every other row/column with the background color",
"Erase every other row/column with the background color", 
"Federico Mena Quintero",
"Federico Mena Quintero",
"June 1997",
"<Image>/Ruby-Fu/Alchemy/Erase every other Row...",
"RGB*, GRAY*, INDEXED*",
[
  [RF_IMAGE,      "image",       "Image"],
  [RF_DRAWABLE,   "drawable",    "Drawable"],
  [RF_OPTION,     "orientation", "Rows/Cols",  0, ["Rows", "Columns"]],
  [RF_OPTION,     "which",       "Even/Odd",   0, ["Even", "Odd"]],
  [RF_OPTION,     "type",        "Erase/Fill", 0, ["Erase", "Fill with BG"]],
],
[]
) { |*args|
  erase_rows(*args)
}

main()
