#!/usr/bin/env ruby
require "gimp"
require 'drb/drb'
include Gimp

def druby_server(run_mode)
  DRb.start_service(nil, Gimp)
  if run_mode == RUN_INTERACTIVE
    message(format("dRuby server is started.\n(%s)\n", DRb.uri))
  end
  DRb.thread.join
end


class <<PLUG_IN_INFO

  def query
    install_procedure("ruby_fu_druby_server",
  		      "dRuby Server",
  		      "dRuby Server",
  		      "Masahiro Sakai",
  		      "Masahiro Sakai",
  		      "2001",
  		      "<Toolbox>/Xtns/Ruby-Fu/dRuby Server...",
  		      "",
  		      EXTENSION,
  		      [
  			[PDB_INT32, "run_mode", "Interactive, non-interactive"],
  		      ],
  		      [])
  end

  def run(name, run_mode, *args)
    case name
    when "ruby_fu_druby_server"
      druby_server(run_mode, *args)
    else
      raise PDB::CallingError
    end
  end

end


main()
