#!/usr/bin/env ruby
require "gimp"
include Gimp

class <<PLUG_IN_INFO

  def query
    install_procedure("ruby_fu_list_images",
		      "Test",
		      "Test",
		      "Masahiro Sakai",
		      "Masahiro Sakai",
		      "2001",
		      "<Toolbox>/Xtns/Ruby-Fu/Misc/List Images...",
		      "RGB*, GRAY*",
		      EXTENSION,
		      [
			[PDB_INT32, "run_mode", "Interactive, non-interactive"],
		      ],
		      [])
  end

  def run(proc_name, *params)
    case proc_name
    when "ruby_fu_list_images"
      list = Image.list
      if list.size == 0
	message("No images")
      else
	list.each { |image|
	  message(format("filename = %s\n", image.get_filename) +
		  format("width = %d\n", image.width) +
		  format("height = %d\n", image.height) +
		  format("id = %d\n", image.gimp_id))
	}
      end
    else
      raise PDB::CallingError
    end
  end

end


main()
